SET NAMES utf8mb4;

CREATE TABLE IF NOT EXISTS tinkoff_invest.currency
(
    currency_id INT AUTO_INCREMENT,
    iso VARCHAR(7) NOT NULL,
    symbol VARCHAR(7) NOT NULL,
    name VARCHAR(255) NOT NULL,
    PRIMARY KEY (currency_id),
    INDEX inx_users_login(iso),
    UNIQUE KEY unq_users_login(iso)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT 'Справочник валют';

INSERT IGNORE INTO tinkoff_invest.currency (iso, symbol, name)
VALUES
       ('RUB', '₽', 'Российский рубль'),
       ('USD', '$', 'Доллар США'),
       ('EUR', '€', 'Евро'),
       ('CNY', '¥', 'Китайский Юань'),
       ('HKD', 'HK$', 'Гонконгский доллар');

CREATE TABLE IF NOT EXISTS tinkoff_invest.market_sector
(
    market_sector_id INT AUTO_INCREMENT,
    external_id VARCHAR(255) NOT NULL,
    name VARCHAR(255) NOT NULL,
    PRIMARY KEY (market_sector_id),
    INDEX inx_market_sector_external_id(external_id),
    UNIQUE KEY unq_market_sector_external_id(external_id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT 'Sector dictionary';

INSERT IGNORE INTO tinkoff_invest.market_sector (external_id, name)
VALUES
       ('basic_materials', 'Basic Materials'),
       ('consumer_cyclical', 'Consumer Cyclical'),
       ('financial_services', 'Financial Services'),
       ('real_estate', 'Real Estate'),
       ('consumer_defensive', 'Consumer Defensive'),
       ('healthcare', 'Healthcare'),
       ('utilities', 'Utilities'),
       ('communication_services', 'Communication Services'),
       ('energy', 'Energy'),
       ('industrials', 'Industrials'),
       ('technology', 'Technology');

CREATE TABLE IF NOT EXISTS tinkoff_invest.country
(
    iso VARCHAR(3) NOT NULL,
    name VARCHAR(255) NOT NULL,
    continent VARCHAR(255) NOT NULL,
    PRIMARY KEY (iso),
    INDEX inx_users_login(iso),
    UNIQUE KEY unq_users_login(iso)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT 'Справочник стран';

-- https://www.html-code-generator.com/mysql/country-name-table
INSERT IGNORE INTO tinkoff_invest.country (`iso`, `name`, `continent`) VALUES
    ('AF', 'Afghanistan', 'Asia'),
    ('AX', 'Aland Islands', 'Europe'),
    ('AL', 'Albania', 'Europe'),
    ('DZ', 'Algeria', 'Africa'),
    ('AS', 'American Samoa', 'Oceania'),
    ('AD', 'Andorra', 'Europe'),
    ('AO', 'Angola', 'Africa'),
    ('AI', 'Anguilla', 'North America'),
    ('AQ', 'Antarctica', 'Antarctica'),
    ('AG', 'Antigua and Barbuda', 'North America'),
    ('AR', 'Argentina', 'South America'),
    ('AM', 'Armenia', 'Asia'),
    ('AW', 'Aruba', 'North America'),
    ('AU', 'Australia', 'Oceania'),
    ('AT', 'Austria', 'Europe'),
    ('AZ', 'Azerbaijan', 'Asia'),
    ('BS', 'Bahamas', 'North America'),
    ('BH', 'Bahrain', 'Asia'),
    ('BD', 'Bangladesh', 'Asia'),
    ('BB', 'Barbados', 'North America'),
    ('BY', 'Belarus', 'Europe'),
    ('BE', 'Belgium', 'Europe'),
    ('BZ', 'Belize', 'North America'),
    ('BJ', 'Benin', 'Africa'),
    ('BM', 'Bermuda', 'North America'),
    ('BT', 'Bhutan', 'Asia'),
    ('BO', 'Bolivia', 'South America'),
    ('BQ', 'Bonaire, Sint Eustatius and Saba', 'North America'),
    ('BA', 'Bosnia and Herzegovina', 'Europe'),
    ('BW', 'Botswana', 'Africa'),
    ('BV', 'Bouvet Island', 'Antarctica'),
    ('BR', 'Brazil', 'South America'),
    ('IO', 'British Indian Ocean Territory', 'Asia'),
    ('BN', 'Brunei Darussalam', 'Asia'),
    ('BG', 'Bulgaria', 'Europe'),
    ('BF', 'Burkina Faso', 'Africa'),
    ('BI', 'Burundi', 'Africa'),
    ('KH', 'Cambodia', 'Asia'),
    ('CM', 'Cameroon', 'Africa'),
    ('CA', 'Canada', 'North America'),
    ('CV', 'Cape Verde', 'Africa'),
    ('KY', 'Cayman Islands', 'North America'),
    ('CF', 'Central African Republic', 'Africa'),
    ('TD', 'Chad', 'Africa'),
    ('CL', 'Chile', 'South America'),
    ('CN', 'China', 'Asia'),
    ('CX', 'Christmas Island', 'Asia'),
    ('CC', 'Cocos (Keeling) Islands', 'Asia'),
    ('CO', 'Colombia', 'South America'),
    ('KM', 'Comoros', 'Africa'),
    ('CG', 'Congo', 'Africa'),
    ('CD', 'Congo, Democratic Republic of the Congo', 'Africa'),
    ('CK', 'Cook Islands', 'Oceania'),
    ('CR', 'Costa Rica', 'North America'),
    ('CI', 'Cote D\'Ivoire', 'Africa'),
    ('HR', 'Croatia', 'Europe'),
    ('CU', 'Cuba', 'North America'),
    ('CW', 'Curacao', 'North America'),
    ('CY', 'Cyprus', 'Asia'),
    ('CZ', 'Czech Republic', 'Europe'),
    ('DK', 'Denmark', 'Europe'),
    ('DJ', 'Djibouti', 'Africa'),
    ('DM', 'Dominica', 'North America'),
    ('DO', 'Dominican Republic', 'North America'),
    ('EC', 'Ecuador', 'South America'),
    ('EG', 'Egypt', 'Africa'),
    ('SV', 'El Salvador', 'North America'),
    ('GQ', 'Equatorial Guinea', 'Africa'),
    ('ER', 'Eritrea', 'Africa'),
    ('EE', 'Estonia', 'Europe'),
    ('ET', 'Ethiopia', 'Africa'),
    ('FK', 'Falkland Islands (Malvinas)', 'South America'),
    ('FO', 'Faroe Islands', 'Europe'),
    ('FJ', 'Fiji', 'Oceania'),
    ('FI', 'Finland', 'Europe'),
    ('FR', 'France', 'Europe'),
    ('GF', 'French Guiana', 'South America'),
    ('PF', 'French Polynesia', 'Oceania'),
    ('TF', 'French Southern Territories', 'Antarctica'),
    ('GA', 'Gabon', 'Africa'),
    ('GM', 'Gambia', 'Africa'),
    ('GE', 'Georgia', 'Asia'),
    ('DE', 'Germany', 'Europe'),
    ('GH', 'Ghana', 'Africa'),
    ('GI', 'Gibraltar', 'Europe'),
    ('GR', 'Greece', 'Europe'),
    ('GL', 'Greenland', 'North America'),
    ('GD', 'Grenada', 'North America'),
    ('GP', 'Guadeloupe', 'North America'),
    ('GU', 'Guam', 'Oceania'),
    ('GT', 'Guatemala', 'North America'),
    ('GG', 'Guernsey', 'Europe'),
    ('GN', 'Guinea', 'Africa'),
    ('GW', 'Guinea-Bissau', 'Africa'),
    ('GY', 'Guyana', 'South America'),
    ('HT', 'Haiti', 'North America'),
    ('HM', 'Heard Island and Mcdonald Islands', 'Antarctica'),
    ('VA', 'Holy See (Vatican City State)', 'Europe'),
    ('HN', 'Honduras', 'North America'),
    ('HK', 'Hong Kong', 'Asia'),
    ('HU', 'Hungary', 'Europe'),
    ('IS', 'Iceland', 'Europe'),
    ('IN', 'India', 'Asia'),
    ('ID', 'Indonesia', 'Asia'),
    ('IR', 'Iran, Islamic Republic of', 'Asia'),
    ('IQ', 'Iraq', 'Asia'),
    ('IE', 'Ireland', 'Europe'),
    ('IM', 'Isle of Man', 'Europe'),
    ('IL', 'Israel', 'Asia'),
    ('IT', 'Italy', 'Europe'),
    ('JM', 'Jamaica', 'North America'),
    ('JP', 'Japan', 'Asia'),
    ('JE', 'Jersey', 'Europe'),
    ('JO', 'Jordan', 'Asia'),
    ('KZ', 'Kazakhstan', 'Asia'),
    ('KE', 'Kenya', 'Africa'),
    ('KI', 'Kiribati', 'Oceania'),
    ('KP', 'Korea, Democratic People\'s Republic of', 'Asia'),
    ('KR', 'Korea, Republic of', 'Asia'),
    ('XK', 'Kosovo', 'Europe'),
    ('KW', 'Kuwait', 'Asia'),
    ('KG', 'Kyrgyzstan', 'Asia'),
    ('LA', 'Lao People\'s Democratic Republic', 'Asia'),
    ('LV', 'Latvia', 'Europe'),
    ('LB', 'Lebanon', 'Asia'),
    ('LS', 'Lesotho', 'Africa'),
    ('LR', 'Liberia', 'Africa'),
    ('LY', 'Libyan Arab Jamahiriya', 'Africa'),
    ('LI', 'Liechtenstein', 'Europe'),
    ('LT', 'Lithuania', 'Europe'),
    ('LU', 'Luxembourg', 'Europe'),
    ('MO', 'Macao', 'Asia'),
    ('MK', 'Macedonia, the Former Yugoslav Republic of', 'Europe'),
    ('MG', 'Madagascar', 'Africa'),
    ('MW', 'Malawi', 'Africa'),
    ('MY', 'Malaysia', 'Asia'),
    ('MV', 'Maldives', 'Asia'),
    ('ML', 'Mali', 'Africa'),
    ('MT', 'Malta', 'Europe'),
    ('MH', 'Marshall Islands', 'Oceania'),
    ('MQ', 'Martinique', 'North America'),
    ('MR', 'Mauritania', 'Africa'),
    ('MU', 'Mauritius', 'Africa'),
    ('YT', 'Mayotte', 'Africa'),
    ('MX', 'Mexico', 'North America'),
    ('FM', 'Micronesia, Federated States of', 'Oceania'),
    ('MD', 'Moldova, Republic of', 'Europe'),
    ('MC', 'Monaco', 'Europe'),
    ('MN', 'Mongolia', 'Asia'),
    ('ME', 'Montenegro', 'Europe'),
    ('MS', 'Montserrat', 'North America'),
    ('MA', 'Morocco', 'Africa'),
    ('MZ', 'Mozambique', 'Africa'),
    ('MM', 'Myanmar', 'Asia'),
    ('NA', 'Namibia', 'Africa'),
    ('NR', 'Nauru', 'Oceania'),
    ('NP', 'Nepal', 'Asia'),
    ('NL', 'Netherlands', 'Europe'),
    ('AN', 'Netherlands Antilles', 'North America'),
    ('NC', 'New Caledonia', 'Oceania'),
    ('NZ', 'New Zealand', 'Oceania'),
    ('NI', 'Nicaragua', 'North America'),
    ('NE', 'Niger', 'Africa'),
    ('NG', 'Nigeria', 'Africa'),
    ('NU', 'Niue', 'Oceania'),
    ('NF', 'Norfolk Island', 'Oceania'),
    ('MP', 'Northern Mariana Islands', 'Oceania'),
    ('NO', 'Norway', 'Europe'),
    ('OM', 'Oman', 'Asia'),
    ('PK', 'Pakistan', 'Asia'),
    ('PW', 'Palau', 'Oceania'),
    ('PS', 'Palestinian Territory, Occupied', 'Asia'),
    ('PA', 'Panama', 'North America'),
    ('PG', 'Papua New Guinea', 'Oceania'),
    ('PY', 'Paraguay', 'South America'),
    ('PE', 'Peru', 'South America'),
    ('PH', 'Philippines', 'Asia'),
    ('PN', 'Pitcairn', 'Oceania'),
    ('PL', 'Poland', 'Europe'),
    ('PT', 'Portugal', 'Europe'),
    ('PR', 'Puerto Rico', 'North America'),
    ('QA', 'Qatar', 'Asia'),
    ('RE', 'Reunion', 'Africa'),
    ('RO', 'Romania', 'Europe'),
    ('RU', 'Russian Federation', 'Europe'),
    ('RW', 'Rwanda', 'Africa'),
    ('BL', 'Saint Barthelemy', 'North America'),
    ('SH', 'Saint Helena', 'Africa'),
    ('KN', 'Saint Kitts and Nevis', 'North America'),
    ('LC', 'Saint Lucia', 'North America'),
    ('MF', 'Saint Martin', 'North America'),
    ('PM', 'Saint Pierre and Miquelon', 'North America'),
    ('VC', 'Saint Vincent and the Grenadines', 'North America'),
    ('WS', 'Samoa', 'Oceania'),
    ('SM', 'San Marino', 'Europe'),
    ('ST', 'Sao Tome and Principe', 'Africa'),
    ('SA', 'Saudi Arabia', 'Asia'),
    ('SN', 'Senegal', 'Africa'),
    ('RS', 'Serbia', 'Europe'),
    ('CS', 'Serbia and Montenegro', 'Europe'),
    ('SC', 'Seychelles', 'Africa'),
    ('SL', 'Sierra Leone', 'Africa'),
    ('SG', 'Singapore', 'Asia'),
    ('SX', 'Sint Maarten', 'North America'),
    ('SK', 'Slovakia', 'Europe'),
    ('SI', 'Slovenia', 'Europe'),
    ('SB', 'Solomon Islands', 'Oceania'),
    ('SO', 'Somalia', 'Africa'),
    ('ZA', 'South Africa', 'Africa'),
    ('GS', 'South Georgia and the South Sandwich Islands', 'Antarctica'),
    ('SS', 'South Sudan', 'Africa'),
    ('ES', 'Spain', 'Europe'),
    ('LK', 'Sri Lanka', 'Asia'),
    ('SD', 'Sudan', 'Africa'),
    ('SR', 'Suriname', 'South America'),
    ('SJ', 'Svalbard and Jan Mayen', 'Europe'),
    ('SZ', 'Swaziland', 'Africa'),
    ('SE', 'Sweden', 'Europe'),
    ('CH', 'Switzerland', 'Europe'),
    ('SY', 'Syrian Arab Republic', 'Asia'),
    ('TW', 'Taiwan, Province of China', 'Asia'),
    ('TJ', 'Tajikistan', 'Asia'),
    ('TZ', 'Tanzania, United Republic of', 'Africa'),
    ('TH', 'Thailand', 'Asia'),
    ('TL', 'Timor-Leste', 'Asia'),
    ('TG', 'Togo', 'Africa'),
    ('TK', 'Tokelau', 'Oceania'),
    ('TO', 'Tonga', 'Oceania'),
    ('TT', 'Trinidad and Tobago', 'North America'),
    ('TN', 'Tunisia', 'Africa'),
    ('TR', 'Turkey', 'Asia'),
    ('TM', 'Turkmenistan', 'Asia'),
    ('TC', 'Turks and Caicos Islands', 'North America'),
    ('TV', 'Tuvalu', 'Oceania'),
    ('UG', 'Uganda', 'Africa'),
    ('UA', 'Ukraine', 'Europe'),
    ('AE', 'United Arab Emirates', 'Asia'),
    ('GB', 'United Kingdom', 'Europe'),
    ('US', 'United States', 'North America'),
    ('UM', 'United States Minor Outlying Islands', 'North America'),
    ('UY', 'Uruguay', 'South America'),
    ('UZ', 'Uzbekistan', 'Asia'),
    ('VU', 'Vanuatu', 'Oceania'),
    ('VE', 'Venezuela', 'South America'),
    ('VN', 'Viet Nam', 'Asia'),
    ('VG', 'Virgin Islands, British', 'North America'),
    ('VI', 'Virgin Islands, U.s.', 'North America'),
    ('WF', 'Wallis and Futuna', 'Oceania'),
    ('EH', 'Western Sahara', 'Africa'),
    ('YE', 'Yemen', 'Asia'),
    ('ZM', 'Zambia', 'Africa'),
    ('ZW', 'Zimbabwe', 'Africa');

ALTER TABLE tinkoff_invest.market_stock
    ADD CONSTRAINT market_stock_country_iso_fk
        FOREIGN KEY (country) REFERENCES country (iso);